<html>
<head>
<title>OGRE: OgreSkeleton.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreSkeleton.h</h1><a href="OgreSkeleton_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#ifndef __Skeleton_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#define __Skeleton_H__</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreResource_8h.html">OgreResource.h</a>"</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreQuaternion_8h.html">OgreQuaternion.h</a>"</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include "<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>"</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include "<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>"</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include "<a class="code" href="OgreStringVector_8h.html">OgreStringVector.h</a>"</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">namespace </span>Ogre {
<a name="l00041"></a>00041 
<a name="l00043"></a><a class="code" href="namespaceOgre.html#230b218164ffe5e6ee8970bef57e6abd">00043</a>     <span class="keyword">enum</span> <a class="code" href="namespaceOgre.html#230b218164ffe5e6ee8970bef57e6abd">SkeletonAnimationBlendMode</a> {
<a name="l00045"></a><a class="code" href="namespaceOgre.html#230b218164ffe5e6ee8970bef57e6abd4d13dab20a3642f5fc20cf2bec22c2c3">00045</a>         <a class="code" href="namespaceOgre.html#230b218164ffe5e6ee8970bef57e6abd4d13dab20a3642f5fc20cf2bec22c2c3" title="Animations are applied by calculating a weighted average of all animations.">ANIMBLEND_AVERAGE</a>,
<a name="l00047"></a><a class="code" href="namespaceOgre.html#230b218164ffe5e6ee8970bef57e6abd5628f84206e4555c948422d2e62b7793">00047</a>         <a class="code" href="namespaceOgre.html#230b218164ffe5e6ee8970bef57e6abd5628f84206e4555c948422d2e62b7793" title="Animations are applied by calculating a weighted cumulative total.">ANIMBLEND_CUMULATIVE</a>
<a name="l00048"></a>00048     };
<a name="l00049"></a>00049 
<a name="l00050"></a><a class="code" href="OgreSkeleton_8h.html#4393e2afffe021cb323b896779de3d17">00050</a> <span class="preprocessor">#define OGRE_MAX_NUM_BONES 256</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span>
<a name="l00052"></a>00052     
<a name="l00053"></a>00053     <span class="keyword">struct </span>LinkedSkeletonAnimationSource;
<a name="l00054"></a>00054 
<a name="l00080"></a><a class="code" href="classOgre_1_1Skeleton.html">00080</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Resource.html" title="Abstract class reprensenting a loadable resource (e.g.">Resource</a>
<a name="l00081"></a>00081     {
<a name="l00082"></a><a class="code" href="classOgre_1_1Skeleton.html#091f8c455d475a25c676a71ba577fa07">00082</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1SkeletonInstance.html" title="A SkeletonInstance is a single instance of a Skeleton used by a world object.">SkeletonInstance</a>;
<a name="l00083"></a>00083     <span class="keyword">protected</span>:
<a name="l00085"></a>00085         <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>();
<a name="l00086"></a>00086 
<a name="l00087"></a>00087     <span class="keyword">public</span>:
<a name="l00093"></a>00093         <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#a1814a97f96347b215b50c11ac2ad09b">ResourceHandle</a> handle,
<a name="l00094"></a>00094             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual = <span class="keyword">false</span>, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader = 0);
<a name="l00095"></a>00095         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>();
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00111"></a>00111         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* createBone(<span class="keywordtype">void</span>);
<a name="l00112"></a>00112 
<a name="l00126"></a>00126         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* createBone(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle);
<a name="l00127"></a>00127 
<a name="l00141"></a>00141         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* createBone(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00142"></a>00142 
<a name="l00153"></a>00153         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* createBone(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle);
<a name="l00154"></a>00154 
<a name="l00156"></a>00156         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNumBones(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00157"></a>00157 
<a name="l00169"></a>00169         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* getRootBone(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00170"></a>00170 
<a name="l00171"></a><a class="code" href="classOgre_1_1Skeleton.html#d4af07ba90c848759e9b3a993efeb952">00171</a>         <span class="keyword">typedef</span> std::vector&lt;Bone*&gt; BoneList;
<a name="l00172"></a><a class="code" href="classOgre_1_1Skeleton.html#9174ebaa5262a5aee4dff1978bb80412">00172</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">VectorIterator&lt;BoneList&gt;</a> <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">BoneIterator</a>;
<a name="l00174"></a>00174         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">BoneIterator</a> getRootBoneIterator(<span class="keywordtype">void</span>);
<a name="l00176"></a>00176         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">BoneIterator</a> getBoneIterator(<span class="keywordtype">void</span>);
<a name="l00177"></a>00177 
<a name="l00179"></a>00179         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* getBone(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle) <span class="keyword">const</span>;
<a name="l00180"></a>00180 
<a name="l00182"></a>00182         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* getBone(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name) <span class="keyword">const</span>;
<a name="l00183"></a>00183 
<a name="l00187"></a>00187         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setBindingPose(<span class="keywordtype">void</span>);
<a name="l00188"></a>00188 
<a name="l00198"></a>00198         <span class="keyword">virtual</span> <span class="keywordtype">void</span> reset(<span class="keywordtype">bool</span> resetManualBones = <span class="keyword">false</span>);
<a name="l00199"></a>00199 
<a name="l00204"></a>00204         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* createAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> length);
<a name="l00205"></a>00205 
<a name="l00214"></a>00214         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* getAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00215"></a>00215             <span class="keyword">const</span> <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html" title="Link to another skeleton to share animations.">LinkedSkeletonAnimationSource</a>** linker = 0) <span class="keyword">const</span>;
<a name="l00216"></a>00216 
<a name="l00218"></a>00218         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* _getAnimationImpl(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00219"></a>00219             <span class="keyword">const</span> <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html" title="Link to another skeleton to share animations.">LinkedSkeletonAnimationSource</a>** linker = 0) <span class="keyword">const</span>;
<a name="l00220"></a>00220 
<a name="l00221"></a>00221 
<a name="l00223"></a>00223         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> hasAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00224"></a>00224 
<a name="l00226"></a>00226         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeAnimation(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00227"></a>00227 
<a name="l00239"></a>00239         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setAnimationState(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AnimationStateSet.html" title="Class encapsulating a set of AnimationState objects.">AnimationStateSet</a>&amp; animSet);
<a name="l00240"></a>00240 
<a name="l00241"></a>00241 
<a name="l00246"></a>00246         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _initAnimationState(<a class="code" href="classOgre_1_1AnimationStateSet.html" title="Class encapsulating a set of AnimationState objects.">AnimationStateSet</a>* animSet);
<a name="l00247"></a>00247 
<a name="l00252"></a>00252         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _refreshAnimationState(<a class="code" href="classOgre_1_1AnimationStateSet.html" title="Class encapsulating a set of AnimationState objects.">AnimationStateSet</a>* animSet);
<a name="l00253"></a>00253 
<a name="l00260"></a>00260         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _getBoneMatrices(<a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a>* pMatrices);
<a name="l00261"></a>00261 
<a name="l00263"></a>00263         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNumAnimations(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00264"></a>00264 
<a name="l00270"></a>00270         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>* getAnimation(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index) <span class="keyword">const</span>;
<a name="l00271"></a>00271 
<a name="l00272"></a>00272 
<a name="l00274"></a>00274         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#230b218164ffe5e6ee8970bef57e6abd">SkeletonAnimationBlendMode</a> getBlendMode() <span class="keyword">const</span>;
<a name="l00276"></a>00276         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setBlendMode(<a class="code" href="namespaceOgre.html#230b218164ffe5e6ee8970bef57e6abd">SkeletonAnimationBlendMode</a> state);
<a name="l00277"></a>00277 
<a name="l00279"></a>00279         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _updateTransforms(<span class="keywordtype">void</span>);
<a name="l00280"></a>00280 
<a name="l00286"></a>00286         <span class="keyword">virtual</span> <span class="keywordtype">void</span> optimiseAllAnimations(<span class="keywordtype">bool</span> preservingIdentityNodeTracks = <span class="keyword">false</span>);
<a name="l00287"></a>00287 
<a name="l00321"></a>00321         <span class="keyword">virtual</span> <span class="keywordtype">void</span> addLinkedSkeletonAnimationSource(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; skelName, 
<a name="l00322"></a>00322             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scale = 1.0f);
<a name="l00324"></a>00324         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeAllLinkedSkeletonAnimationSources(<span class="keywordtype">void</span>);
<a name="l00325"></a>00325         
<a name="l00326"></a>00326         <span class="keyword">typedef</span> std::vector&lt;LinkedSkeletonAnimationSource&gt; 
<a name="l00327"></a><a class="code" href="classOgre_1_1Skeleton.html#fdfc1f1d1b1fa14d29d5509d36f4d5e0">00327</a>             LinkedSkeletonAnimSourceList;
<a name="l00328"></a>00328         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Wraps iteration over a const vector.">ConstVectorIterator&lt;LinkedSkeletonAnimSourceList&gt;</a> 
<a name="l00329"></a><a class="code" href="classOgre_1_1Skeleton.html#e93aeeef114b2c5d9db170d0beda944b">00329</a>             <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Wraps iteration over a const vector.">LinkedSkeletonAnimSourceIterator</a>;
<a name="l00331"></a>00331         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Wraps iteration over a const vector.">LinkedSkeletonAnimSourceIterator</a> 
<a name="l00332"></a>00332             getLinkedSkeletonAnimationSourceIterator(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00333"></a>00333 
<a name="l00335"></a>00335         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyManualBonesDirty(<span class="keywordtype">void</span>);
<a name="l00337"></a>00337         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyManualBoneStateChange(<a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* bone);
<a name="l00338"></a>00338 
<a name="l00340"></a><a class="code" href="classOgre_1_1Skeleton.html#be8363fb958cb666ac2c12cb9cde844f">00340</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getManualBonesDirty(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mManualBonesDirty; }
<a name="l00342"></a><a class="code" href="classOgre_1_1Skeleton.html#c9a9e603f2da6248b004f3f958a69664">00342</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> hasManualBones(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> !mManualBones.empty(); }
<a name="l00343"></a>00343 
<a name="l00345"></a><a class="code" href="classOgre_1_1Skeleton.html#0b88d4537f7b1ef7a4fe41f5be3c5e30">00345</a>         <span class="keyword">typedef</span> std::vector&lt;ushort&gt; BoneHandleMap;
<a name="l00346"></a>00346 
<a name="l00380"></a>00380         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _mergeSkeletonAnimations(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* source,
<a name="l00381"></a>00381             <span class="keyword">const</span> BoneHandleMap&amp; boneHandleMap,
<a name="l00382"></a>00382             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#783e5227595f351519627abfb740ec85">StringVector</a>&amp; animations = <a class="code" href="namespaceOgre.html#783e5227595f351519627abfb740ec85">StringVector</a>());
<a name="l00383"></a>00383 
<a name="l00388"></a>00388         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _buildMapBoneByHandle(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* source,
<a name="l00389"></a>00389             BoneHandleMap&amp; boneHandleMap) <span class="keyword">const</span>;
<a name="l00390"></a>00390 
<a name="l00395"></a>00395         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _buildMapBoneByName(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* source,
<a name="l00396"></a>00396             BoneHandleMap&amp; boneHandleMap) <span class="keyword">const</span>;
<a name="l00397"></a>00397 
<a name="l00398"></a>00398     <span class="keyword">protected</span>:
<a name="l00399"></a><a class="code" href="classOgre_1_1Skeleton.html#20571d720d0f33cbc98adba63bec3b3d">00399</a>         <a class="code" href="namespaceOgre.html#230b218164ffe5e6ee8970bef57e6abd">SkeletonAnimationBlendMode</a> mBlendState;
<a name="l00401"></a><a class="code" href="classOgre_1_1Skeleton.html#0164943c64c4d4634046c40eba6c6914">00401</a>         BoneList mBoneList;
<a name="l00403"></a><a class="code" href="classOgre_1_1Skeleton.html#11792fdd187f2a61c4acc8e7d1310226">00403</a>         <span class="keyword">typedef</span> std::map&lt;String, Bone*&gt; BoneListByName;
<a name="l00404"></a><a class="code" href="classOgre_1_1Skeleton.html#51de68b26bf9a15ef399686713ac739b">00404</a>         BoneListByName mBoneListByName;
<a name="l00405"></a>00405 
<a name="l00406"></a>00406 
<a name="l00408"></a><a class="code" href="classOgre_1_1Skeleton.html#29e96975d05f528c597b93871088de8b">00408</a>         <span class="keyword">mutable</span> BoneList mRootBones;
<a name="l00410"></a><a class="code" href="classOgre_1_1Skeleton.html#23e247a9b511eaa21e772d3ff3bb4b5f">00410</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> mNextAutoHandle;
<a name="l00411"></a><a class="code" href="classOgre_1_1Skeleton.html#940b0ac2020e674c30125a76c502adb2">00411</a>         <span class="keyword">typedef</span> std::set&lt;Bone*&gt; BoneSet;
<a name="l00413"></a><a class="code" href="classOgre_1_1Skeleton.html#22374d7c595a7aacc812906b025d41f0">00413</a>         BoneSet mManualBones;
<a name="l00415"></a><a class="code" href="classOgre_1_1Skeleton.html#a41c36e353417b99d64c31fb8a39c3af">00415</a>         <span class="keywordtype">bool</span> mManualBonesDirty;
<a name="l00416"></a>00416 
<a name="l00417"></a>00417 
<a name="l00419"></a><a class="code" href="classOgre_1_1Skeleton.html#55d6c0837479ccc8a2c37455b123c7fc">00419</a>         <span class="keyword">typedef</span> std::map&lt;String, Animation*&gt; AnimationList;
<a name="l00420"></a><a class="code" href="classOgre_1_1Skeleton.html#d9304a32da9742c346eb2c24dfeaef94">00420</a>         AnimationList mAnimationsList;
<a name="l00421"></a>00421 
<a name="l00423"></a><a class="code" href="classOgre_1_1Skeleton.html#d714391a25cdf4eb435c269d882e7904">00423</a>         <span class="keyword">mutable</span> LinkedSkeletonAnimSourceList mLinkedSkeletonAnimSourceList;
<a name="l00424"></a>00424 
<a name="l00430"></a>00430         <span class="keywordtype">void</span> deriveRootBone(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00431"></a>00431 
<a name="l00433"></a>00433         <span class="keywordtype">void</span> _dumpContents(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename);
<a name="l00434"></a>00434 
<a name="l00437"></a>00437         <span class="keywordtype">void</span> loadImpl(<span class="keywordtype">void</span>);
<a name="l00438"></a>00438 
<a name="l00441"></a>00441         <span class="keywordtype">void</span> unloadImpl(<span class="keywordtype">void</span>);
<a name="l00443"></a><a class="code" href="classOgre_1_1Skeleton.html#fa83f6f72123b2e69ca5e96951934209">00443</a>         <span class="keywordtype">size_t</span> calculateSize(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; } <span class="comment">// TODO </span>
<a name="l00444"></a>00444 
<a name="l00445"></a>00445     };
<a name="l00446"></a>00446 
<a name="l00453"></a><a class="code" href="classOgre_1_1SkeletonPtr.html">00453</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr</a>&lt;Skeleton&gt; 
<a name="l00454"></a>00454     {
<a name="l00455"></a>00455     <span class="keyword">public</span>:
<a name="l00456"></a><a class="code" href="classOgre_1_1SkeletonPtr.html#74423f10c7e83538c3f5463db84bd3fb">00456</a>         <a class="code" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a>() : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>&gt;() {}
<a name="l00457"></a><a class="code" href="classOgre_1_1SkeletonPtr.html#a8fa63c93390b57f1e2abc2caf8647b2">00457</a>         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a>(<a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* rep) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>&gt;(rep) {}
<a name="l00458"></a><a class="code" href="classOgre_1_1SkeletonPtr.html#f3243f7eae18ed75d6d0ca6484a13a4d">00458</a>         <a class="code" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>&gt;(r) {} 
<a name="l00459"></a><a class="code" href="classOgre_1_1SkeletonPtr.html#6658dde5b31d0bbf51c7b1af9e1b58c3">00459</a>         <a class="code" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">ResourcePtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>&gt;()
<a name="l00460"></a>00460         {
<a name="l00461"></a>00461             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00462"></a>00462             <a class="code" href="OgrePrerequisites_8h.html#2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00463"></a>00463             {
<a name="l00464"></a>00464                 <a class="code" href="OgrePrerequisites_8h.html#8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00465"></a>00465                 <a class="code" href="OgrePrerequisites_8h.html#cf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00466"></a>00466                 pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00467"></a>00467                 pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00468"></a>00468                 <span class="keywordflow">if</span> (pUseCount)
<a name="l00469"></a>00469                 {
<a name="l00470"></a>00470                     ++(*pUseCount);
<a name="l00471"></a>00471                 }
<a name="l00472"></a>00472             }
<a name="l00473"></a>00473         }
<a name="l00474"></a>00474 
<a name="l00476"></a><a class="code" href="classOgre_1_1SkeletonPtr.html#08db394bd29df84c7e3f1f2977c17395">00476</a>         <a class="code" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">ResourcePtr</a>&amp; r)
<a name="l00477"></a>00477         {
<a name="l00478"></a>00478             <span class="keywordflow">if</span> (pRep == static_cast&lt;Skeleton*&gt;(r.<a class="code" href="classOgre_1_1SharedPtr.html#15e055008751a7c20bdde38662d5f0a1">getPointer</a>()))
<a name="l00479"></a>00479                 <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00480"></a>00480             release();
<a name="l00481"></a>00481             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00482"></a>00482             <a class="code" href="OgrePrerequisites_8h.html#2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00483"></a>00483             {
<a name="l00484"></a>00484                 <a class="code" href="OgrePrerequisites_8h.html#8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00485"></a>00485                 <a class="code" href="OgrePrerequisites_8h.html#cf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00486"></a>00486                 pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00487"></a>00487                 pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00488"></a>00488                 <span class="keywordflow">if</span> (pUseCount)
<a name="l00489"></a>00489                 {
<a name="l00490"></a>00490                     ++(*pUseCount);
<a name="l00491"></a>00491                 }
<a name="l00492"></a>00492             }
<a name="l00493"></a>00493             <span class="keywordflow">else</span>
<a name="l00494"></a>00494             {
<a name="l00495"></a>00495                 <span class="comment">// RHS must be a null pointer</span>
<a name="l00496"></a>00496                 assert(r.<a class="code" href="classOgre_1_1SharedPtr.html#8a223db784efd7aa766792649de2f2a0">isNull</a>() &amp;&amp; <span class="stringliteral">"RHS must be null if it has no mutex!"</span>);
<a name="l00497"></a>00497                 setNull();
<a name="l00498"></a>00498             }
<a name="l00499"></a>00499             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00500"></a>00500         }
<a name="l00501"></a>00501     };
<a name="l00502"></a>00502 
<a name="l00504"></a><a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html">00504</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html" title="Link to another skeleton to share animations.">LinkedSkeletonAnimationSource</a>
<a name="l00505"></a>00505     {
<a name="l00506"></a><a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#18367921f5c2e7eddaf14a54dacd3484">00506</a>         <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#18367921f5c2e7eddaf14a54dacd3484">skeletonName</a>;
<a name="l00507"></a><a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#02c73a85564ec0047f8de9b71e771331">00507</a>         <a class="code" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a> <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#02c73a85564ec0047f8de9b71e771331">pSkeleton</a>;
<a name="l00508"></a><a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#79bb4debcd21595087623b9a8d17d121">00508</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#79bb4debcd21595087623b9a8d17d121">scale</a>;
<a name="l00509"></a><a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#7a01cb43456b193136f19dd60e9ec7f2">00509</a>         <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#7a01cb43456b193136f19dd60e9ec7f2">LinkedSkeletonAnimationSource</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; skelName, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scl)
<a name="l00510"></a>00510             : <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#18367921f5c2e7eddaf14a54dacd3484">skeletonName</a>(skelName), <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#79bb4debcd21595087623b9a8d17d121">scale</a>(scl) {}
<a name="l00511"></a><a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#d04b9f46242d6c0f8226f423274a3c40">00511</a>             <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#7a01cb43456b193136f19dd60e9ec7f2">LinkedSkeletonAnimationSource</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; skelName, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scl, 
<a name="l00512"></a>00512                 <a class="code" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a> skelPtr)
<a name="l00513"></a>00513                 : <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#18367921f5c2e7eddaf14a54dacd3484">skeletonName</a>(skelName), <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#02c73a85564ec0047f8de9b71e771331">pSkeleton</a>(skelPtr), <a class="code" href="structOgre_1_1LinkedSkeletonAnimationSource.html#79bb4debcd21595087623b9a8d17d121">scale</a>(scl) {}
<a name="l00514"></a>00514     };
<a name="l00515"></a>00515 }
<a name="l00516"></a>00516 
<a name="l00517"></a>00517 
<a name="l00518"></a>00518 <span class="preprocessor">#endif</span>
<a name="l00519"></a>00519 <span class="preprocessor"></span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:56 2008
</p>
</body>
</html>
